﻿/*
    Program demonstrujici vyuziti dedicnosti.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Datum
{
    class Datum
    {
        private byte den, mesic;
        private ushort rok;

        public Datum(byte d, byte m, ushort r)
        {
            den = d;
            mesic = m;
            rok = r;
        }

        public byte GetDen()
        {
            return den;
        }

        public byte GetMesic()
        {
            return mesic;
        }

        public ushort GetRok()
        {
            return rok;
        }

        public void SetDen(byte d)
        {
            den = d;
        }

        public void SetMesic(byte m)
        {
            mesic = m;
        }

        public void SetRok(ushort r)
        {
            rok = r;
        }

        public string GetDatum()
        {
            return den + ". " + mesic + ". " + rok;
            //return den.ToString() + ". " + mesic.ToString() + ". " + rok.ToString();
        }

        public bool JePrestupnyRok()
        {
            if (rok % 4 != 0)
                return false;
            else if (rok % 100 != 0)
                return true;
            else if (rok % 400 != 0)
                return false;
            else return true;
        }
    }

    class DatumRoz : Datum
    {
        public DatumRoz(byte d, byte m, ushort r)
            : base(d, m, r)
        {
        }

        public void PrictiDen()
        {
            if (GetDen() < DniVMesici())
                SetDen(Convert.ToByte(GetDen() + 1));
            else if (GetMesic() < 12)
            {
                SetMesic(Convert.ToByte(GetMesic() + 1));
                SetDen(1);
            }
            else
            {
                SetRok(Convert.ToUInt16(GetRok() + 1));
                SetMesic(1);
                SetDen(1);
            }
        }

        public void OdectiDen()
        {
            if (GetDen() > 1)
                SetDen(Convert.ToByte(GetDen() - 1));
            else if (GetMesic() > 1)
            {
                SetMesic(Convert.ToByte(GetMesic() - 1));
                SetDen(DniVMesici());
            }
            else
            {
                SetRok(Convert.ToUInt16(GetRok() - 1));
                SetMesic(12);
                SetDen(31);
            }
        }

        private byte DniVMesici()
        {
            switch (GetMesic())
            {
                case 1:
                case 3:
                case 5:
                case 7:
                case 8:
                case 10:
                case 12: return 31;
                case 4:
                case 6:
                case 9:
                case 11: return 30;
                case 2: if (JePrestupnyRok())
                        return 29;
                    else return 28;
                default: return 0;
            }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            DatumRoz datRoz1 = new DatumRoz(1, 1, 2000);
            DatumRoz datRoz2 = new DatumRoz(1, 1, 2000);

            Console.WriteLine("Nastavene datum je: {0}", datRoz1.GetDatum());
            datRoz1.PrictiDen();
            Console.WriteLine("Nasledujici den ma datum: {0}", datRoz1.GetDatum());
            Console.WriteLine();

            Console.WriteLine("Nastavene datum je: {0}", datRoz2.GetDatum());
            datRoz2.OdectiDen();
            Console.WriteLine("Predchazejici den ma datum: {0}", datRoz2.GetDatum());
        }
    }
}
