﻿/*
    Program predvadejici pouziti vlastnosti.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Datum
{
    class Datum
    {
        private byte den, mesic;
        private ushort rok;

        public byte Den
        {
            get
            {
                return den;
            }
            set
            {
                den = value;
            }
        }

        public byte Mesic
        {
            get
            {
                return mesic;
            }
            set
            {
                mesic = value;
            }
        }

        public ushort Rok
        {
            get
            {
                return rok;
            }
            set
            {
                rok = value;
            }
        }

        public Datum(byte d, byte m, ushort r)
        {
            den = d;
            mesic = m;
            rok = r;
        }

        public override string ToString()
        {
            return den + ". " + mesic + ". " + rok;
        }

        public bool JePrestupnyRok()
        {
            if (rok % 4 != 0)
                return false;
            else if (rok % 100 != 0)
                return true;
            else if (rok % 400 != 0)
                return false;
            else return true;
        }
    }

    class DatumRoz : Datum
    {
        public DatumRoz(byte d, byte m, ushort r)
            : base(d, m, r)
        {
        }

        public void PrictiDen()
        {
            if (Den < DniVMesici())
                Den++;
            else if (Mesic < 12)
            {
                Mesic++;
                Den = 1;
            }
            else
            {
                Rok++;
                Mesic = 1;
                Den = 1;
            }
        }

        public void OdectiDen()
        {
            if (Den > 1)
                Den--;
            else if (Mesic > 1)
            {
                Mesic--;
                Den = DniVMesici();
            }
            else
            {
                Rok--;
                Mesic = 12;
                Den = 31;
            }
        }

        private byte DniVMesici()
        {
            switch (Mesic)
            {
                case 1:
                case 3:
                case 5:
                case 7:
                case 8:
                case 10:
                case 12: return 31;
                case 4:
                case 6:
                case 9:
                case 11: return 30;
                case 2: if (JePrestupnyRok())
                        return 29;
                    else return 28;
                default: return 0;
            }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            DatumRoz datRoz1 = new DatumRoz(1, 1, 2000);
            DatumRoz datRoz2 = new DatumRoz(1, 1, 2000);

            Console.WriteLine("Nastavene datum je: {0}", datRoz1.ToString());
            datRoz1.PrictiDen();
            Console.WriteLine("Nasledujici den ma datum: {0}", datRoz1.ToString());
            Console.WriteLine();

            Console.WriteLine("Nastavene datum je: {0}", datRoz2.ToString());
            datRoz2.OdectiDen();
            Console.WriteLine("Predchazejici den ma datum: {0}", datRoz2.ToString());
            Console.WriteLine();

            datRoz1.Den = 10;
            datRoz1.Mesic = 5;
            datRoz1.Rok = 2010;

            Console.WriteLine("Nastavene datum je: {0}", datRoz1.ToString());
            datRoz1.PrictiDen();
            Console.WriteLine("Nasledujici den ma datum: {0}", datRoz1.ToString());
        }
    }
}

